#!/perl/bin/perl
# package Mine::MyModule;
package Formula;
use Lingua::Stem::Snowball;
use Lingua::StopWords qw( getStopWords );
use warnings;
use strict;

my $i=1;
my %ni;

my $N = 0;






our $stemmer = Lingua::Stem::Snowball->new(
lang     => 'en', 
encoding => 'UTF-8',
);
die $@ if $@;

my $stopwords = getStopWords('en', 'UTF-8');

sub stemmmStopword {
#Vetor com o texto que vai ser feito o Stemming e StopWords, tambem pode utilizar vetor com palavras.
	
my @words_array = @_;	


# #Faz o Stemming do array
 my @resp_stemm = $stemmer->stem([@words_array]);


# #Imprimi o Texto Original (Apenas para comparação )
 #my $size = scalar my @bug_array;


# #Imprimi texto depois de passar pelo Stemming e StopWords
 my @resposta =  grep {!$stopwords->{$_}}@resp_stemm,; # Vetor @bug onde fica armazenado o texto final
 
 
 return @resposta;

}



sub documentFrequency	{
	my %tf;
	foreach my $word (@_)
	{	
	
	
		
	
		if($word ne ''){
		
			
			
			if(defined($tf{$word})&&($tf{$word}->[0] eq $word)){
				my $temp1 = $tf{$word}->[1]+1;	
				$tf{$word}=[$word,$temp1];
				
			}
			else{
				$tf{$word}=[$word,1];

				
                                if(defined($ni{$word})&& $ni{$word}->[0] eq $word&& ($word ne '') ){
	
				 my $temp = $ni{$word}->[1]+1;
				 $ni{$word} = [$word,$temp];	
		
			
	
				}elsif($word ne ''){
		
				  $ni{$word}=[$word,1];
				}

				







				
			}

	
 


		
		}
	
	
		
	}
	


 $N++;
 return %tf;
}





#my %ni = ni(@resposta);

#my %ni1 = ni(@resposta1);
#my @keys = keys(%tf);
  


	#foreach my $key(@keys){
		
		
		#print("$tf{$key}->[0] $tf{$key}->[1] ");

      
	
       #}




#ajusta o peso de acordo com a função do logaritimo.
sub ajustePeso{
my %pesoAjustado;


my %tf = documentFrequency(@_);



my @keys = keys(%tf);
  

	foreach my $key(@keys){
		
		$pesoAjustado{$key} = [(1+log(1+$tf{$key}->[1])) * log(1+$N / $ni{$key}->[1])];
		#print("$ni{$key}->[0] $ni{$key}->[1]  $tf{$key}->[1]  \n");

                #rint(log(($N / $ni{$key}->[1])));
		#print("$key =" );
		#print("$pesoAjustado{$key}->[0]  \n"); 
	
       }



	
 return %pesoAjustado;
}	

#calcula com Similaridade do Cosseno 
sub  cosineSimilar{

 my @queryPrincipal =  @{$_[0]};
 my @otherBug =  @{$_[1]};
 my %weightQuery = ajustePeso(@queryPrincipal);

 my %weightOther = ajustePeso(@otherBug);
 my @keys = keys(%weightQuery);	

 #Somatório dos pesos  do Documento x query principal 
 my $tempz = 0; 
  foreach my $key(@keys){

    	if(defined($weightOther{$key})){
	  $tempz = $tempz + ($weightOther{$key}->[0]*$weightQuery{$key}->[0]);	
		
	}

   }

#Somatório dos pesos ao quadrado de cada Documento
  my $temp1 = 0;
  my $temp2 = 0; 
   foreach my $key(@keys){
    	
	if(defined($weightQuery{$key})){
     
	  	
	  $temp2 = $temp2 + ($weightQuery{$key}->[0]**2);
	  		
	}

   }


	@keys = keys(%weightOther);


	
  foreach my $key(@keys){
    	
	if(defined($weightOther{$key})){
     
	  $temp1 = $temp1 + ($weightOther{$key}->[0]**2);
	  	 		
	
	  		
	}

   }





  #raiz dos resultados
  # print("entreiT $tempz\n");
     # print("entrei $temp2\n");
     # print("entrei 1  $temp1\n");	
   $temp1   = sqrt($temp1);
   $temp2   = sqrt($temp2);

 #aplicação da fórmula
   
   my $result =  $tempz/($temp1*$temp2);
  
 #print "N = $N\n";
 return $result;
}



#testando com 2 textos iguais 















